/***************************************************************************
                          cleanupwizard.h  -  description
                             -------------------
    begin                : Sat Aug 12 2000
    copyright            : (C) 2000 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          cleanupwizard.h  -  description
                             -------------------
    begin                : Mon Dec 20 1999
    copyright            : (C) 1999 by Arjan Buursink
    email                : buursink@casema.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CLEANUPWIZARD_H
#define CLEANUPWIZARD_H

#include <kwizard.h>
#include "cleanupwizard_1.h"
#include "cleanupwizard_2.h"
#include "cleanupwizard_3.h"
#include "filegroupext.h"
#include "abprogress.h"
#include "batch.h"
#include "logviewer.h"

/**
  *@author Arjan Buursink
  */

class CleanUpWizard : public KWizard  {
	Q_OBJECT
public:
	CleanUpWizard(FileGroupExt *, QWidget * parent = 0, const char * name = 0, bool model = true);
	~CleanUpWizard();
  void setFileGroup(FileGroupExt * f){fileGroup = f;};
private:
	CleanUpWizard_1 * cleanUpWizard_1;
	CleanUpWizard_2 * cleanUpWizard_2;
	CleanUpWizard_3 * cleanUpWizard_3;
	QWidget *page_1, *page_2, *page_3;
	FileGroupExt * fileGroup;
	void setTextPage_3(QString);
	ABProgress * progress;
	ABProcess * proc;
	Batch * batch;
	LogViewer * logViewer;
	void accept();
	void reject(){emit ready(); delete this;};
private slots:
	void slotDeleteClicked();
	void slotArchiveClicked();
	void slotMoveClicked();
	void slotBrowseClicked();
	void slotCleanUpCompleted();
	void slotViewLog();
	void slotCancel();
signals:
	void ready();
};

#endif
