/***************************************************************************
                          tgz.h  -  description
                             -------------------
    begin                : Sat Aug 12 2000
    copyright            : (C) 2000 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
/***************************************************************************
                          tgz.h  -  description
                             -------------------
    begin                : Fri Dec 17 1999
    copyright            : (C) 1999 by Arjan Buursink
    email                : buursink@casema.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef TGZ_H
#define TGZ_H

#include <filegroupext.h>

/**
  *@author Arjan Buursink
  */

class TGZ : public FileGroupExt  {
	Q_OBJECT
public:
	TGZ(const QString);
	~TGZ();
	/**
	* Creates a File Group of files which belong to the archive with @param filename
	*/
	TGZ(const QString filename, const QString dirname);
	/**
	 * Loads a group from disk with filename filename. This member function
	 * loads the files from the archive.
	 */
	void load();
	void loadConfig();
	void loadFiles();
	/**
	 * Saves the group to disk.
	 */
	void save();
	void saveConfig();
	void saveFiles();
	void setArchiveRoot(QString s);
	QString archiveRoot(){return archrt;};
private:
	ABProcess * p;
	void addDir(QString s){dirList -> append(s);};
	QStrList * dirList;
	bool dirHasChild(QString);
	QString archrt;
private slots:
	void slotTarExtractProcessEnded();
};

#endif
